'********************************************************************
'                            Sanduhr.BAS
'
'(c) Ing.Bro Stefan Lehmann, Frstenbergstrae 8a, 77756 Hausach
'********************************************************************
         $LIST /M_OBJ        'falls ein HEX-File erzeugt werden soll, mssen
         $LIST OBJ2HEX       'diese beiden Zeilen aktiv sein. Dadurch wird
                             'ein Microchip konformes HEX-File erzeugt
         
         define device 16F628A, irc_osc, wdt_on, osc2_io , mclr_int, t0cs_int, psa1, psv7, cmcfg7
         xtal 4
         define zeitzeiger = auto
         define zeit1 = auto
         define zeit2 = auto
         define zeit3 = auto
         define zeit4 = auto
         define zeit5 = auto
         define bild1 = auto
         define bild2 = auto
         define bild3 = auto
         define bild4 = auto
         define bild5 = auto
         define riesel1 = auto
         define riesel2 = auto
         define riesel3 = auto
         define riesel4 = auto
         define riesel5 = auto

         define rieselzeiger = auto
         define counter = auto
         define interval = auto
         define spalte = auto
         define temp = auto
         define tmp = auto
         define ii = auto
         define jj = auto
         define kk = auto
         define zeile = auto
         define editmin = auto
         define editsek = auto
         define intervalconst = auto
         
         define minus = ra,7           'Zeit herunterzhlen
         define plus = ra,6            'Zeit hochzhlen
         define on_key = ra,5          'Ein-Taster (Auto-OFF)
         

'         $debug
         $wdtusr                       'wegen Sleep-Befehl


cold:
         wait 200
         tris ra,%11100000             'Datenrichtung der IO-Pins
         tris rb,%00000000             
         output ra,255                 'alles ausschalten
         output rb,0
         set rb,0                      'Batterie-Einschaltkontrolle
         res ra,2
         wait 2000
         output ra,255
         output rb,0
         read 5, temp                  'Zeitspeicher leer?
         if temp>9 then goto init    'ja, Defaultwert setzen
         read 10,temp
         if temp>9 then goto init
         goto schlafe
init:
         write 5,3                     'Defaultminute = 3
         write 10,0                    'defaultsekunde = 0
         goto schlafe         

display:
         for jj=1 to 33
           clrwdt
           gosub disp
         next jj
         return          
disp:
         let spalte = %11111110
         let tmp=4
         for ii = 0 to 4
           let temp=bild1(ii) 'tmp)         'Bildinfo holen und ausgeben
           output rb,temp
           output ra,spalte
           wait 1
           rotl8 spalte
           dec tmp
         next ii
         output ra,255                 'alles aus
         return
         
dispedit:
         restore Minuten
         let temp=0
dispedit1:
         readdata bild1,bild2,bild3,bild4,bild5         
         if temp=editmin then goto dispedit2
         inc temp
         goto dispedit1
dispedit2:
         restore Sekunden
         let temp=0
dispedit3:
         readdata zeit1,zeit2,zeit3,zeit4,zeit5
         if temp=editsek then goto dispedit4
         inc temp
         goto dispedit3
dispedit4:
         let bild1 = bild1 or zeit1
         let bild2 = bild2 or zeit2
         let bild3 = bild3 or zeit3
         let bild4 = bild4 or zeit4
         let bild5 = bild5 or zeit5
         gosub display
         return                                    

'Hauptschleife, wird beim Drcken von EIN aus Schlafen: aufgerufen.
loop:
         wait 200
         tris ra,%11100000             'Datenrichtung der IO-Pins
         tris rb,%00000000             
         output ra,255                 'alles ausschalten
         output rb,0
         let counter=19                '19 Bilder, dann Sanduhr abgelaufen
         read 5, editmin
         read 10,editsek
         let interval=editmin * 18
         let temp = editsek * 3
         let intervalconst=interval + temp
         let interval=intervalconst
         let zeitzeiger=0
         let rieselzeiger=0
loop1:
         restore zeit
         let temp=0                    'entsprechend Zeiger weiterstellen
loop2:
         readdata zeit1,zeit2,zeit3,zeit4,zeit5
         if temp=zeitzeiger then goto loop3
         inc temp
         goto loop2
loop3:                  
         restore riesel
         let temp=0
loop4:
         readdata riesel1,riesel2,riesel3,riesel4,riesel5         
         if temp=rieselzeiger then goto loop5
         inc temp
         goto loop4
loop5:         
         if minus=0 then goto schlafe
         inc rieselzeiger
         if rieselzeiger>2 then let rieselzeiger=0
         let bild1 = zeit1 or riesel1
         let bild2 = zeit2 or riesel2
         let bild3 = zeit3 or riesel3
         let bild4 = zeit4 or riesel4
         let bild5 = zeit5 or riesel5
         gosub display
         dec interval
         if interval<>0 then goto loop3
         let interval=intervalconst
         inc zeitzeiger
         dec counter
         if counter<>0 then goto loop1
         res bild2,3
         for kk=1 to 20
           gosub display
           wait 300
         next kk
schlafe:
         tris ra,255                   'alles auf Eingang
         tris rb,255
         sleep 1                       'ergibt ca. 2,3 Sek.
         if plus=0 then goto einstellen
'         if minus=0 then goto einstellen         
         if on_key=1 then goto schlafe
         goto loop

einstellen:
         read 5,editmin
         read 10,editsek
         tris ra,%11100000             'Datenrichtung der IO-Pins
         tris rb,%00000000             
         output ra,255                 'alles ausschalten
         output rb,0
einstellen1:
         gosub dispedit                   'Editzeit anzeigen
         if plus=0 then goto einstellen1  'warte bis alle Tasten frei sind
         if minus=0 then goto einstellen1
einstellen2:
         gosub dispedit
         if plus=1 then goto einstellen3
         inc editsek
         if editsek<6 then goto einstellen1
         let editsek=0
         inc editmin
         if editmin<10 then goto einstellen1
         let editmin=0
         goto einstellen1
einstellen3:
         if minus=1 then goto einstellen4
         dec editsek
         if editsek<>255 then goto einstellen1
         let editsek=5
         dec editmin
         if editmin<>255 then goto einstellen1
         let editmin=9
         goto einstellen1         
einstellen4:
         if on_key=1 then goto einstellen2       'keine Taste gedrckt         
         if editsek<>0 then goto einstellen5     'darf nie 0,0 sein
         if editmin=0 then inc editsek           'sondern min. 0,1
einstellen5:
         write 5,editmin
         write 10,editsek
         goto loop                               'Uhr starten
         
Riesel:
         data $08,$10,$80,$00,$00
         data $00,$00,$20,$00,$10
         data $00,$00,$40,$10,$00
         
Zeit:
         data $07,$0f,$0f,$0f,$0f
         data $07,$0f,$8e,$0f,$0f
         data $07,$0f,$8e,$8e,$0f
         data $07,$8e,$8e,$8e,$0f
         data $07,$8e,$cc,$8e,$0f  'ok ---
         data $87,$8e,$cc,$8e,$0e
         data $86,$8e,$cc,$8e,$8e  '
         data $86,$ce,$cc,$8c,$8e         
         data $86,$cc,$cc,$cc,$8e
         data $86,$cc,$e8,$cc,$8e
         data $86,$cc,$e8,$cc,$cc
         data $86,$cc,$e8,$e8,$cc
         data $c4,$cc,$e8,$e8,$cc
         data $c4,$e8,$e8,$e8,$cc
         data $c4,$f8,$e8,$e8,$c8
         data $c0,$f8,$e8,$e8,$e8 '--
         data $c0,$f8,$f8,$e8,$e0
         data $e0,$f8,$f0,$e8,$e0
         data $f0,$f8,$f0,$e0,$e0
         data $f0,$f0,$f0,$f0,$e0
         data $00

Minuten:
         data $e0,$a0,$a0,$a0,$e0      '0
         data $40,$40,$40,$40,$40      '1
         data $e0,$80,$e0,$20,$e0      '2
         data $e0,$20,$e0,$20,$e0      '3
         data $20,$20,$e0,$a0,$a0      '4
         data $e0,$20,$e0,$80,$e0      '5
         data $e0,$a0,$e0,$80,$e0      '6
         data $20,$20,$20,$20,$e0      '7
         data $e0,$a0,$e0,$a0,$e0      '8
         data $e0,$20,$e0,$a0,$e0      '9
         data $00
Sekunden:
         data $07,$05,$05,$05,$07      '0
         data $02,$02,$02,$02,$02      '1
         data $07,$04,$07,$01,$07      '2
         data $07,$01,$07,$01,$07      '3
         data $01,$01,$07,$05,$05      '4
         data $07,$01,$07,$04,$07      '5
         data $07,$05,$07,$04,$07      '6
         data $01,$01,$01,$01,$07      '7
         data $07,$05,$07,$05,$07      '8
         data $07,$01,$07,$05,$07      '9
         data $00
         end     
                  